// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package acl_runtime

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetServicesHaproxyRuntimeAclsParentNameEntriesOKCode is the HTTP code returned for type GetServicesHaproxyRuntimeAclsParentNameEntriesOK
const GetServicesHaproxyRuntimeAclsParentNameEntriesOKCode int = 200

/*
GetServicesHaproxyRuntimeAclsParentNameEntriesOK Successful operation

swagger:response getServicesHaproxyRuntimeAclsParentNameEntriesOK
*/
type GetServicesHaproxyRuntimeAclsParentNameEntriesOK struct {

	/*
	  In: Body
	*/
	Payload models.ACLFilesEntries `json:"body,omitempty"`
}

// NewGetServicesHaproxyRuntimeAclsParentNameEntriesOK creates GetServicesHaproxyRuntimeAclsParentNameEntriesOK with default headers values
func NewGetServicesHaproxyRuntimeAclsParentNameEntriesOK() *GetServicesHaproxyRuntimeAclsParentNameEntriesOK {

	return &GetServicesHaproxyRuntimeAclsParentNameEntriesOK{}
}

// WithPayload adds the payload to the get services haproxy runtime acls parent name entries o k response
func (o *GetServicesHaproxyRuntimeAclsParentNameEntriesOK) WithPayload(payload models.ACLFilesEntries) *GetServicesHaproxyRuntimeAclsParentNameEntriesOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get services haproxy runtime acls parent name entries o k response
func (o *GetServicesHaproxyRuntimeAclsParentNameEntriesOK) SetPayload(payload models.ACLFilesEntries) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetServicesHaproxyRuntimeAclsParentNameEntriesOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.ACLFilesEntries{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

// GetServicesHaproxyRuntimeAclsParentNameEntriesBadRequestCode is the HTTP code returned for type GetServicesHaproxyRuntimeAclsParentNameEntriesBadRequest
const GetServicesHaproxyRuntimeAclsParentNameEntriesBadRequestCode int = 400

/*
GetServicesHaproxyRuntimeAclsParentNameEntriesBadRequest Bad request

swagger:response getServicesHaproxyRuntimeAclsParentNameEntriesBadRequest
*/
type GetServicesHaproxyRuntimeAclsParentNameEntriesBadRequest struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetServicesHaproxyRuntimeAclsParentNameEntriesBadRequest creates GetServicesHaproxyRuntimeAclsParentNameEntriesBadRequest with default headers values
func NewGetServicesHaproxyRuntimeAclsParentNameEntriesBadRequest() *GetServicesHaproxyRuntimeAclsParentNameEntriesBadRequest {

	return &GetServicesHaproxyRuntimeAclsParentNameEntriesBadRequest{}
}

// WithConfigurationVersion adds the configurationVersion to the get services haproxy runtime acls parent name entries bad request response
func (o *GetServicesHaproxyRuntimeAclsParentNameEntriesBadRequest) WithConfigurationVersion(configurationVersion string) *GetServicesHaproxyRuntimeAclsParentNameEntriesBadRequest {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get services haproxy runtime acls parent name entries bad request response
func (o *GetServicesHaproxyRuntimeAclsParentNameEntriesBadRequest) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get services haproxy runtime acls parent name entries bad request response
func (o *GetServicesHaproxyRuntimeAclsParentNameEntriesBadRequest) WithPayload(payload *models.Error) *GetServicesHaproxyRuntimeAclsParentNameEntriesBadRequest {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get services haproxy runtime acls parent name entries bad request response
func (o *GetServicesHaproxyRuntimeAclsParentNameEntriesBadRequest) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetServicesHaproxyRuntimeAclsParentNameEntriesBadRequest) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(400)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

// GetServicesHaproxyRuntimeAclsParentNameEntriesNotFoundCode is the HTTP code returned for type GetServicesHaproxyRuntimeAclsParentNameEntriesNotFound
const GetServicesHaproxyRuntimeAclsParentNameEntriesNotFoundCode int = 404

/*
GetServicesHaproxyRuntimeAclsParentNameEntriesNotFound The specified resource was not found

swagger:response getServicesHaproxyRuntimeAclsParentNameEntriesNotFound
*/
type GetServicesHaproxyRuntimeAclsParentNameEntriesNotFound struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetServicesHaproxyRuntimeAclsParentNameEntriesNotFound creates GetServicesHaproxyRuntimeAclsParentNameEntriesNotFound with default headers values
func NewGetServicesHaproxyRuntimeAclsParentNameEntriesNotFound() *GetServicesHaproxyRuntimeAclsParentNameEntriesNotFound {

	return &GetServicesHaproxyRuntimeAclsParentNameEntriesNotFound{}
}

// WithConfigurationVersion adds the configurationVersion to the get services haproxy runtime acls parent name entries not found response
func (o *GetServicesHaproxyRuntimeAclsParentNameEntriesNotFound) WithConfigurationVersion(configurationVersion string) *GetServicesHaproxyRuntimeAclsParentNameEntriesNotFound {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get services haproxy runtime acls parent name entries not found response
func (o *GetServicesHaproxyRuntimeAclsParentNameEntriesNotFound) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get services haproxy runtime acls parent name entries not found response
func (o *GetServicesHaproxyRuntimeAclsParentNameEntriesNotFound) WithPayload(payload *models.Error) *GetServicesHaproxyRuntimeAclsParentNameEntriesNotFound {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get services haproxy runtime acls parent name entries not found response
func (o *GetServicesHaproxyRuntimeAclsParentNameEntriesNotFound) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetServicesHaproxyRuntimeAclsParentNameEntriesNotFound) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(404)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetServicesHaproxyRuntimeAclsParentNameEntriesDefault General Error

swagger:response getServicesHaproxyRuntimeAclsParentNameEntriesDefault
*/
type GetServicesHaproxyRuntimeAclsParentNameEntriesDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetServicesHaproxyRuntimeAclsParentNameEntriesDefault creates GetServicesHaproxyRuntimeAclsParentNameEntriesDefault with default headers values
func NewGetServicesHaproxyRuntimeAclsParentNameEntriesDefault(code int) *GetServicesHaproxyRuntimeAclsParentNameEntriesDefault {
	if code <= 0 {
		code = 500
	}

	return &GetServicesHaproxyRuntimeAclsParentNameEntriesDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get services haproxy runtime acls parent name entries default response
func (o *GetServicesHaproxyRuntimeAclsParentNameEntriesDefault) WithStatusCode(code int) *GetServicesHaproxyRuntimeAclsParentNameEntriesDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get services haproxy runtime acls parent name entries default response
func (o *GetServicesHaproxyRuntimeAclsParentNameEntriesDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get services haproxy runtime acls parent name entries default response
func (o *GetServicesHaproxyRuntimeAclsParentNameEntriesDefault) WithConfigurationVersion(configurationVersion string) *GetServicesHaproxyRuntimeAclsParentNameEntriesDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get services haproxy runtime acls parent name entries default response
func (o *GetServicesHaproxyRuntimeAclsParentNameEntriesDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get services haproxy runtime acls parent name entries default response
func (o *GetServicesHaproxyRuntimeAclsParentNameEntriesDefault) WithPayload(payload *models.Error) *GetServicesHaproxyRuntimeAclsParentNameEntriesDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get services haproxy runtime acls parent name entries default response
func (o *GetServicesHaproxyRuntimeAclsParentNameEntriesDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetServicesHaproxyRuntimeAclsParentNameEntriesDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
