// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package backend_switching_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// ReplaceBackendSwitchingRulesHandlerFunc turns a function with the right signature into a replace backend switching rules handler
type ReplaceBackendSwitchingRulesHandlerFunc func(ReplaceBackendSwitchingRulesParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn ReplaceBackendSwitchingRulesHandlerFunc) Handle(params ReplaceBackendSwitchingRulesParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// ReplaceBackendSwitchingRulesHandler interface for that can handle valid replace backend switching rules params
type ReplaceBackendSwitchingRulesHandler interface {
	Handle(ReplaceBackendSwitchingRulesParams, interface{}) middleware.Responder
}

// NewReplaceBackendSwitchingRules creates a new http.Handler for the replace backend switching rules operation
func NewReplaceBackendSwitchingRules(ctx *middleware.Context, handler ReplaceBackendSwitchingRulesHandler) *ReplaceBackendSwitchingRules {
	return &ReplaceBackendSwitchingRules{Context: ctx, Handler: handler}
}

/*
	ReplaceBackendSwitchingRules swagger:route PUT /services/haproxy/configuration/frontends/{parent_name}/backend_switching_rules BackendSwitchingRule replaceBackendSwitchingRules

# Replace an Backend Switching Rule list

Replaces a whole list of Backend Switching Rules with the list given in parameter
*/
type ReplaceBackendSwitchingRules struct {
	Context *middleware.Context
	Handler ReplaceBackendSwitchingRulesHandler
}

func (o *ReplaceBackendSwitchingRules) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		*r = *rCtx
	}
	var Params = NewReplaceBackendSwitchingRulesParams()
	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		*r = *aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc.(interface{}) // this is really a interface{}, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}
