// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package bind

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// GetAllBindPeerHandlerFunc turns a function with the right signature into a get all bind peer handler
type GetAllBindPeerHandlerFunc func(GetAllBindPeerParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetAllBindPeerHandlerFunc) Handle(params GetAllBindPeerParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetAllBindPeerHandler interface for that can handle valid get all bind peer params
type GetAllBindPeerHandler interface {
	Handle(GetAllBindPeerParams, interface{}) middleware.Responder
}

// NewGetAllBindPeer creates a new http.Handler for the get all bind peer operation
func NewGetAllBindPeer(ctx *middleware.Context, handler GetAllBindPeerHandler) *GetAllBindPeer {
	return &GetAllBindPeer{Context: ctx, Handler: handler}
}

/*
	GetAllBindPeer swagger:route GET /services/haproxy/configuration/peers/{parent_name}/binds Bind getAllBindPeer

# Return an array of binds

Returns an array of all binds that are configured in specified frontend.
*/
type GetAllBindPeer struct {
	Context *middleware.Context
	Handler GetAllBindPeerHandler
}

func (o *GetAllBindPeer) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		*r = *rCtx
	}
	var Params = NewGetAllBindPeerParams()
	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		*r = *aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc.(interface{}) // this is really a interface{}, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}
