// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package crt_store

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// EditCrtStoreHandlerFunc turns a function with the right signature into a edit crt store handler
type EditCrtStoreHandlerFunc func(EditCrtStoreParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn EditCrtStoreHandlerFunc) Handle(params EditCrtStoreParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// EditCrtStoreHandler interface for that can handle valid edit crt store params
type EditCrtStoreHandler interface {
	Handle(EditCrtStoreParams, interface{}) middleware.Responder
}

// NewEditCrtStore creates a new http.Handler for the edit crt store operation
func NewEditCrtStore(ctx *middleware.Context, handler EditCrtStoreHandler) *EditCrtStore {
	return &EditCrtStore{Context: ctx, Handler: handler}
}

/*
	EditCrtStore swagger:route PUT /services/haproxy/configuration/crt_stores/{name} CrtStore editCrtStore

# Modify a Certificate Store

Modifies a crt_store's configuration by its name
*/
type EditCrtStore struct {
	Context *middleware.Context
	Handler EditCrtStoreHandler
}

func (o *EditCrtStore) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		*r = *rCtx
	}
	var Params = NewEditCrtStoreParams()
	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		*r = *aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc.(interface{}) // this is really a interface{}, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}
