// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package defaults

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// CreateDefaultsSectionHandlerFunc turns a function with the right signature into a create defaults section handler
type CreateDefaultsSectionHandlerFunc func(CreateDefaultsSectionParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn CreateDefaultsSectionHandlerFunc) Handle(params CreateDefaultsSectionParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// CreateDefaultsSectionHandler interface for that can handle valid create defaults section params
type CreateDefaultsSectionHandler interface {
	Handle(CreateDefaultsSectionParams, interface{}) middleware.Responder
}

// NewCreateDefaultsSection creates a new http.Handler for the create defaults section operation
func NewCreateDefaultsSection(ctx *middleware.Context, handler CreateDefaultsSectionHandler) *CreateDefaultsSection {
	return &CreateDefaultsSection{Context: ctx, Handler: handler}
}

/*
	CreateDefaultsSection swagger:route PUT /services/haproxy/configuration/defaults Defaults createDefaultsSection

# Add a defaults section

Adds a new defaults section to the configuration file.
*/
type CreateDefaultsSection struct {
	Context *middleware.Context
	Handler CreateDefaultsSectionHandler
}

func (o *CreateDefaultsSection) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		*r = *rCtx
	}
	var Params = NewCreateDefaultsSectionParams()
	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		*r = *aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc.(interface{}) // this is really a interface{}, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}
