// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package dgram_bind

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// CreateDgramBindHandlerFunc turns a function with the right signature into a create dgram bind handler
type CreateDgramBindHandlerFunc func(CreateDgramBindParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn CreateDgramBindHandlerFunc) Handle(params CreateDgramBindParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// CreateDgramBindHandler interface for that can handle valid create dgram bind params
type CreateDgramBindHandler interface {
	Handle(CreateDgramBindParams, interface{}) middleware.Responder
}

// NewCreateDgramBind creates a new http.Handler for the create dgram bind operation
func NewCreateDgramBind(ctx *middleware.Context, handler CreateDgramBindHandler) *CreateDgramBind {
	return &CreateDgramBind{Context: ctx, Handler: handler}
}

/*
	CreateDgramBind swagger:route POST /services/haproxy/configuration/log_forwards/{parent_name}/dgram_binds DgramBind createDgramBind

# Add a new dgram bind

Adds a new dgram bind in the specified log forward in the configuration file.
*/
type CreateDgramBind struct {
	Context *middleware.Context
	Handler CreateDgramBindHandler
}

func (o *CreateDgramBind) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		*r = *rCtx
	}
	var Params = NewCreateDgramBindParams()
	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		*r = *aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc.(interface{}) // this is really a interface{}, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}
