// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package filter

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v6/models"
)

// GetAllFilterBackendOKCode is the HTTP code returned for type GetAllFilterBackendOK
const GetAllFilterBackendOKCode int = 200

/*
GetAllFilterBackendOK Successful operation

swagger:response getAllFilterBackendOK
*/
type GetAllFilterBackendOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload models.Filters `json:"body,omitempty"`
}

// NewGetAllFilterBackendOK creates GetAllFilterBackendOK with default headers values
func NewGetAllFilterBackendOK() *GetAllFilterBackendOK {

	return &GetAllFilterBackendOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get all filter backend o k response
func (o *GetAllFilterBackendOK) WithConfigurationVersion(configurationVersion string) *GetAllFilterBackendOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get all filter backend o k response
func (o *GetAllFilterBackendOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get all filter backend o k response
func (o *GetAllFilterBackendOK) WithPayload(payload models.Filters) *GetAllFilterBackendOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all filter backend o k response
func (o *GetAllFilterBackendOK) SetPayload(payload models.Filters) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllFilterBackendOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	payload := o.Payload
	if payload == nil {
		// return empty array
		payload = models.Filters{}
	}

	if err := producer.Produce(rw, payload); err != nil {
		panic(err) // let the recovery middleware deal with this
	}
}

/*
GetAllFilterBackendDefault General Error

swagger:response getAllFilterBackendDefault
*/
type GetAllFilterBackendDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetAllFilterBackendDefault creates GetAllFilterBackendDefault with default headers values
func NewGetAllFilterBackendDefault(code int) *GetAllFilterBackendDefault {
	if code <= 0 {
		code = 500
	}

	return &GetAllFilterBackendDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get all filter backend default response
func (o *GetAllFilterBackendDefault) WithStatusCode(code int) *GetAllFilterBackendDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get all filter backend default response
func (o *GetAllFilterBackendDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get all filter backend default response
func (o *GetAllFilterBackendDefault) WithConfigurationVersion(configurationVersion string) *GetAllFilterBackendDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get all filter backend default response
func (o *GetAllFilterBackendDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get all filter backend default response
func (o *GetAllFilterBackendDefault) WithPayload(payload *models.Error) *GetAllFilterBackendDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get all filter backend default response
func (o *GetAllFilterBackendDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetAllFilterBackendDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
