// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package http_request_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// CreateHTTPRequestRuleFrontendHandlerFunc turns a function with the right signature into a create HTTP request rule frontend handler
type CreateHTTPRequestRuleFrontendHandlerFunc func(CreateHTTPRequestRuleFrontendParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn CreateHTTPRequestRuleFrontendHandlerFunc) Handle(params CreateHTTPRequestRuleFrontendParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// CreateHTTPRequestRuleFrontendHandler interface for that can handle valid create HTTP request rule frontend params
type CreateHTTPRequestRuleFrontendHandler interface {
	Handle(CreateHTTPRequestRuleFrontendParams, interface{}) middleware.Responder
}

// NewCreateHTTPRequestRuleFrontend creates a new http.Handler for the create HTTP request rule frontend operation
func NewCreateHTTPRequestRuleFrontend(ctx *middleware.Context, handler CreateHTTPRequestRuleFrontendHandler) *CreateHTTPRequestRuleFrontend {
	return &CreateHTTPRequestRuleFrontend{Context: ctx, Handler: handler}
}

/*
	CreateHTTPRequestRuleFrontend swagger:route POST /services/haproxy/configuration/frontends/{parent_name}/http_request_rules/{index} HTTPRequestRule createHttpRequestRuleFrontend

# Add a new HTTP Request Rule

Adds a new HTTP Request Rule of the specified type in the specified parent.
*/
type CreateHTTPRequestRuleFrontend struct {
	Context *middleware.Context
	Handler CreateHTTPRequestRuleFrontendHandler
}

func (o *CreateHTTPRequestRuleFrontend) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		*r = *rCtx
	}
	var Params = NewCreateHTTPRequestRuleFrontendParams()
	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		*r = *aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc.(interface{}) // this is really a interface{}, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}
