// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package http_request_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// GetAllHTTPRequestRuleBackendHandlerFunc turns a function with the right signature into a get all HTTP request rule backend handler
type GetAllHTTPRequestRuleBackendHandlerFunc func(GetAllHTTPRequestRuleBackendParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetAllHTTPRequestRuleBackendHandlerFunc) Handle(params GetAllHTTPRequestRuleBackendParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetAllHTTPRequestRuleBackendHandler interface for that can handle valid get all HTTP request rule backend params
type GetAllHTTPRequestRuleBackendHandler interface {
	Handle(GetAllHTTPRequestRuleBackendParams, interface{}) middleware.Responder
}

// NewGetAllHTTPRequestRuleBackend creates a new http.Handler for the get all HTTP request rule backend operation
func NewGetAllHTTPRequestRuleBackend(ctx *middleware.Context, handler GetAllHTTPRequestRuleBackendHandler) *GetAllHTTPRequestRuleBackend {
	return &GetAllHTTPRequestRuleBackend{Context: ctx, Handler: handler}
}

/*
	GetAllHTTPRequestRuleBackend swagger:route GET /services/haproxy/configuration/backends/{parent_name}/http_request_rules HTTPRequestRule getAllHttpRequestRuleBackend

# Return an array of all HTTP Request Rules

Returns all HTTP Request Rules that are configured in specified parent.
*/
type GetAllHTTPRequestRuleBackend struct {
	Context *middleware.Context
	Handler GetAllHTTPRequestRuleBackendHandler
}

func (o *GetAllHTTPRequestRuleBackend) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		*r = *rCtx
	}
	var Params = NewGetAllHTTPRequestRuleBackendParams()
	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		*r = *aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc.(interface{}) // this is really a interface{}, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}
