// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package stick_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// ReplaceStickRulesHandlerFunc turns a function with the right signature into a replace stick rules handler
type ReplaceStickRulesHandlerFunc func(ReplaceStickRulesParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn ReplaceStickRulesHandlerFunc) Handle(params ReplaceStickRulesParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// ReplaceStickRulesHandler interface for that can handle valid replace stick rules params
type ReplaceStickRulesHandler interface {
	Handle(ReplaceStickRulesParams, interface{}) middleware.Responder
}

// NewReplaceStickRules creates a new http.Handler for the replace stick rules operation
func NewReplaceStickRules(ctx *middleware.Context, handler ReplaceStickRulesHandler) *ReplaceStickRules {
	return &ReplaceStickRules{Context: ctx, Handler: handler}
}

/*
	ReplaceStickRules swagger:route PUT /services/haproxy/configuration/backends/{parent_name}/stick_rules StickRule replaceStickRules

# Replace a Stick Rule list

Replaces a whole list of Stick Rules with the list given in parameter
*/
type ReplaceStickRules struct {
	Context *middleware.Context
	Handler ReplaceStickRulesHandler
}

func (o *ReplaceStickRules) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		*r = *rCtx
	}
	var Params = NewReplaceStickRulesParams()
	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		*r = *aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc.(interface{}) // this is really a interface{}, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}
