// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// DeleteStorageGeneralFileHandlerFunc turns a function with the right signature into a delete storage general file handler
type DeleteStorageGeneralFileHandlerFunc func(DeleteStorageGeneralFileParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn DeleteStorageGeneralFileHandlerFunc) Handle(params DeleteStorageGeneralFileParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// DeleteStorageGeneralFileHandler interface for that can handle valid delete storage general file params
type DeleteStorageGeneralFileHandler interface {
	Handle(DeleteStorageGeneralFileParams, interface{}) middleware.Responder
}

// NewDeleteStorageGeneralFile creates a new http.Handler for the delete storage general file operation
func NewDeleteStorageGeneralFile(ctx *middleware.Context, handler DeleteStorageGeneralFileHandler) *DeleteStorageGeneralFile {
	return &DeleteStorageGeneralFile{Context: ctx, Handler: handler}
}

/*
	DeleteStorageGeneralFile swagger:route DELETE /services/haproxy/storage/general/{name} Storage deleteStorageGeneralFile

# Deletes a managed general use file from disk

Deletes a managed general use file from disk.
*/
type DeleteStorageGeneralFile struct {
	Context *middleware.Context
	Handler DeleteStorageGeneralFileHandler
}

func (o *DeleteStorageGeneralFile) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		*r = *rCtx
	}
	var Params = NewDeleteStorageGeneralFileParams()
	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		*r = *aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc.(interface{}) // this is really a interface{}, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}
