// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// GetOneStorageGeneralFileHandlerFunc turns a function with the right signature into a get one storage general file handler
type GetOneStorageGeneralFileHandlerFunc func(GetOneStorageGeneralFileParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn GetOneStorageGeneralFileHandlerFunc) Handle(params GetOneStorageGeneralFileParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// GetOneStorageGeneralFileHandler interface for that can handle valid get one storage general file params
type GetOneStorageGeneralFileHandler interface {
	Handle(GetOneStorageGeneralFileParams, interface{}) middleware.Responder
}

// NewGetOneStorageGeneralFile creates a new http.Handler for the get one storage general file operation
func NewGetOneStorageGeneralFile(ctx *middleware.Context, handler GetOneStorageGeneralFileHandler) *GetOneStorageGeneralFile {
	return &GetOneStorageGeneralFile{Context: ctx, Handler: handler}
}

/*
	GetOneStorageGeneralFile swagger:route GET /services/haproxy/storage/general/{name} Storage getOneStorageGeneralFile

# Return the contents of one managed general use file from disk

Returns the contents of one managed general use file from disk
*/
type GetOneStorageGeneralFile struct {
	Context *middleware.Context
	Handler GetOneStorageGeneralFileHandler
}

func (o *GetOneStorageGeneralFile) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		*r = *rCtx
	}
	var Params = NewGetOneStorageGeneralFileParams()
	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		*r = *aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc.(interface{}) // this is really a interface{}, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}
