// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package table

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// CreateTableHandlerFunc turns a function with the right signature into a create table handler
type CreateTableHandlerFunc func(CreateTableParams, interface{}) middleware.Responder

// Handle executing the request and returning a response
func (fn CreateTableHandlerFunc) Handle(params CreateTableParams, principal interface{}) middleware.Responder {
	return fn(params, principal)
}

// CreateTableHandler interface for that can handle valid create table params
type CreateTableHandler interface {
	Handle(CreateTableParams, interface{}) middleware.Responder
}

// NewCreateTable creates a new http.Handler for the create table operation
func NewCreateTable(ctx *middleware.Context, handler CreateTableHandler) *CreateTable {
	return &CreateTable{Context: ctx, Handler: handler}
}

/*
	CreateTable swagger:route POST /services/haproxy/configuration/peers/{parent_name}/tables Table createTable

# Add a new table

Adds a new table in the specified peer section in the configuration file.
*/
type CreateTable struct {
	Context *middleware.Context
	Handler CreateTableHandler
}

func (o *CreateTable) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		*r = *rCtx
	}
	var Params = NewCreateTableParams()
	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		*r = *aCtx
	}
	var principal interface{}
	if uprinc != nil {
		principal = uprinc.(interface{}) // this is really a interface{}, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request
	o.Context.Respond(rw, r, route.Produces, route, res)

}
